//FILL CAN//
if($AddOn__Tool_Fill_Can == 1 && isFile("Add-Ons/Tool_Fill_Can.zip"))
{
	exec("./Mode_Fillcan.cs");
}
else
{
	echo("Fill Can not detected. Fill Can mode did not load.");
}
//DELETE//
$SwissArmyGun::Mode_["Delete"] = "Bricks";
$SwissArmyGun::ModeWelcome_["Delete"] = "Deletes a brick without the risk of destroying bricks on top of it.";
$SwissArmyGun::ModeNo[$SwissArmyGun::ModeCount++] = "Delete";
function SwissArmyGun_Delete_Brick(%obj, %col, %pos)
{
	if(getTrustLevel(%obj.getControllingClient(), %col) >= 2 || %obj.getControllingClient().isAdmin)
	{
		%col.delete();
	}
}
//BOMB//
$SwissArmyGun::Mode_["Bomb"] = "Bricks";
$SwissArmyGun::ModeWelcome_["Bomb"] = "Kills all bricks within a radius. Only usable on your own bricks if you're a non-Admin.";
$SwissArmyGun::ModeNo[$SwissArmyGun::ModeCount++] = "Bomb";
function SwissArmyGun_Bomb_Brick(%obj, %col, %pos)
{
	%client = %obj.getControllingClient();
	new projectile()
	{
		datablock = vehicleExplosionProjectile;
		client = 0;
		sourceSlot = 0;
		sourceObject = %obj;
		scale = 2;
		initialPosition = %pos;
		initalVelocity = "0 0 0";
		client = %client;
	};
	InitContainerRadiusSearch(%pos, 15, $Typemasks::FxBrickAlwaysObjectType);
	while(%hit = containerSearchNext())
	{
		if(%hit.isPlanted())
		{
			if(getTrustLevel(%client, %hit) == 3 || %client.isAdmin)
			{
				%hit.killbrick();
			}
		}
	}
}
//CHAIN PRINTER//
$SwissArmyGun::Mode_["PrintFill"] = "Bricks";
$SwissArmyGun::ModeWelcome_["PrintFill"] = "Think of it as a combination of the Fill can and the Printgun.";
$SwissArmyGun::ModeNo[$SwissArmyGun::ModeCount++] = "PrintFill";
function SwissArmyGun_PrintFill_Brick(%obj, %col, %fade, %pos, %normal)
{
	if(isObject(%client = %obj.getControllingClient()))
	{
		if(strLen(%client.lastPrint[%col.getDatablock().printAspectRatio]) > 1 )
		{
			if(strLen(%col.printID) > 1)
			{
				SAG_PrintFill(%col, %client);
			}
			else
			{
				messageClient(%client, '', "<color:ff0000>This mode only effects print bricks.");
			}
		}
		else
		{
			messageClient(%client, '', "<color:ff0000>You need to place a print first.");
		}
	}
}
//Modified fill can function, thanks Zor
function SAG_PrintFill(%obj, %client)
{
	if(getTrustLevel(%client, %obj) < 3)
	{
		%client.centerPrint("<color:FF8888>" @ %obj.getGroup().name @ "<color:FF0000> does not trust you enough to do that.", 2);
		return;
	}
	%data = %obj.getdatablock();
	%list = new scriptobject()
	{
		count = 0;
		oldPrint = %obj.printID;
		newPrint = %client.lastPrint[%data.printAspectRatio];
	};
	%list.obj[-1 + %list.count++] = %obj;
	%obj.printed = 1;
	for(%x = 0; %x < %list.count; %x++)
	{
		%obj = %list.obj[%x];
		%rot = getWord(%brick.rotation, 3);
		%deci = strPos(%key, ".");
		%pos = %deci != -1 ? %deci : strLen(%key);
		%fRot = getSubStr(%key, 0, %pos);
		%data = %obj.getdatablock();
		if(%fRot == 90 || %fRot == 270)
		{
			%sizeX = %data.brickSizeY;
			%sizeY = %data.brickSizeX;
		}
		else
		{
			%sizeX = %data.brickSizeX;
			%sizeY = %data.brickSizeY;
		}
		%sizeZ = %data.brickSizeZ;
		%box = (%sizeX * 0.5 + 0.6) SPC (%sizeY * 0.5 + 0.6) SPC (%sizeZ * 0.2 + 0.3);
		InitContainerBoxSearch(%obj.getPosition(), %box, $TypeMasks::FxBrickAlwaysObjectType);
		while(%target = containerSearchNext())
		{
			if(%target.isPlanted())
			{
				if(getTrustLevel(%client, %target) >= 2)
				{
					if(!%target.printed && %target.printID $= %list.oldPrint)
					{
						%target.printed = 1;
						%list.obj[-1 + %list.count++] = %target;
					}
				}
			}
		}
	}
	for(%x = 0; %x < %list.count; %x++)
	{
		%list.obj[%x].setPrint(%list.newPrint);
	}
	%client.undostack.push(%list TAB "FILLPRINT");
}
package SAG_FillPrint_Undo
{
	//This is modified from the fill can, thanks to Zor
	function serverCmdUndoBrick(%client)
	{
		%str = %client.undoStack.val[%client.undoStack.head-1];
		if(getfield(%str, 1) $= "FILLPRINT")
		{
			%list = getfield(%str, 0);
			for(%x = %list.count - 1; %x > -1; %x--)
			{
				%brick = %list.obj[%x];
				if(isObject(%brick))
				{
					if(%brick.printID $= %list.newPrint)
					{
						%brick.setPrint(%list.oldPrint);
					}
				}
			}
			%client.undostack.pop();
			%list.delete();
			%client.player.playThread(0, undo);
		}
		else
		{
			parent::serverCmdUndoBrick(%client);
		}
	}
};
activatePackage(SAG_FillPrint_Undo);
//NUKE//
$SwissArmyGun::Mode_["Nuke"] = "Bricks";
$SwissArmyGun::ModeWelcome_["Nuke"] = "Destroys the hit brick and all bricks attached to it. Only usable on your own bricks for non-Admins.";
$SwissArmyGun::ModeNo[$SwissArmyGun::ModeCount++] = "Nuke";
function SwissArmyGun_Nuke_Brick(%obj, %col, %pos)
{
	new projectile()
	{
		datablock = vehicleFinalExplosionProjectile;
		client = 0;
		sourceSlot = 0;
		sourceObject = %obj;
		scale = 2;
		initialPosition = %pos;
		initalVelocity = "0 0 0";
	};
	SAG_Nuke(%col, %obj.getControllingClient());
}
//Modified fill can function, thanks Zor
function SAG_Nuke(%obj, %client)
{
	if(getTrustLevel(%client, %obj) < 3 && !%client.isAdmin)
	{
		return;
	}
	%list = new scriptObject()
	{
		count = 0;
	};
	%list.obj[-1 + %list.count++] = %obj;
	%obj.nuked = 1;
	for(%x = 0; %x < %list.count; %x++)
	{
		%obj = %list.obj[%x];
		%rot = getWord(%brick.rotation, 3);
		%data = %obj.getdatablock();
		if(!%rot || %rot == 180)
		{
			%sizeX = %data.brickSizeX;
			%sizeY = %data.brickSizeY;
		}
		else
		{
			%sizeX = %data.brickSizeY;
			%sizeY = %data.brickSizeX;
		}
		%sizeZ = %data.brickSizeZ;
		%box = (%sizeX * 0.5 + 0.6) SPC (%sizeY * 0.5 + 0.6) SPC (%sizeZ * 0.2 + 0.3);
		InitContainerBoxSearch(%obj.getPosition(), %box, $TypeMasks::FxBrickAlwaysObjectType);
		while(%target = containerSearchNext())
		{
			if(%target.isPlanted())
			{
				%trusted = getTrustLevel(%client, %target) == 3;
				%admin = %client.isAdmin;
				if(!strLen(%mode))
				{
					%mode = %trusted ? "trust" : "admin";
					if(%admin)
					{
						%group = %target.getGroup();
					}
				}
				if((%mode $= "trust" && %trusted) || (%mode $= "admin" && %target.getGroup() == %group))
				{
					if(!%target.nuked)
					{
						%target.nuked = 1;
						%list.obj[-1 + %list.count++] = %target;
					}
				}
			}
		}
	}
	for(%x = 0; %x < %list.count; %x++)
	{
		%list.obj[%x].killBrick();
	}
	%list.delete();
}
//MOVER//
$SwissArmyGun::Mode_["Move"] = "Bricks";
$SwissArmyGun::ModeWelcome_["Move"] = "Allows you to pick up a brick and move it. Cancelling the brick will return it to its original position.";
$SwissArmyGun::ModeNo[$SwissArmyGun::ModeCount++] = "Move";
function SwissArmyGun_Move_Brick(%obj, %col, %fade, %pos, %normal)
{
	%client = %obj.getControllingClient();
	if(getTrustLevel(%client, %col) >= 2)
	{
		if(isObject(%temp = %obj.tempBrick))
		{
			serverCmdCancelBrick(%client);
		}
		%brick = new FxDtsBrick()
		{
			position          = %col.position;
			oriPosition       = %col.position;
			rotation          = %col.rotation;
			oriRotation       = %col.rotation;
			dataBlock         = %col.dataBlock;
			oriDataBlock      = %col.dataBlock;
			angleId           = %col.angleId;
			oriAngleId        = %col.angleId;
			colorId           = %col.colorId;
			oriColorId        = %col.colorId;
			printId           = %col.printId;
			oriPrintId        = %col.printId;
			emitterDiection   = %col.emitterDirection;
			oriIsRaycasting   = %col.isRaycasting();
			oriIsColliding    = %col.isColliding();
			oriIsRendering    = %col.isRendering();
			itemDirection     = %col.itemDirection;
			itemPosition      = %col.itemPosition;
			itemResawnTime    = %col.itemRespawnTime;
			colorFxId         = %col.colorFxID;
			shapeFxId         = %col.shapeFxID;
			vehicleDatablock  = %col.vehicleDatablock;
			client            = %client;
			delAfterPlant     = true;
			transferProperties= true;
		};
		%obj.tempBrick = %brick;
		if(isObject(%col.emitter))
		{
			%brick.emitterData = %col.emitter.emitter;
		}
		if(isObject(%col.light))
		{
			%brick.lightData = %col.light.getDatablock();
		}
		if(isObject(%col.item))
		{
			%brick.itemData = %col.item.getDatablock();
		}
		if(isObject(%col.audioEmitter))
		{
			%brick.musicData = %col.audioEmitter.profile;
		}
		//Events
		%brick.numEvents = %col.numEvents;
		for(%i = 0; %i < %col.numEvents; %i++)
		{
			%brick.eventDelay[%i] = %col.eventDelay[%i];
			%brick.eventEnabled[%i] = %col.eventEnabled[%i];
			%brick.eventInput[%i] = %col.eventInput[%i];
			%brick.eventInputIdx[%i] = %col.eventInputIdx[%i];
			%brick.eventOutput[%i] = %col.eventOutput[%i];
			%brick.eventOutputAppendClient[%i] = %col.eventOutputAppendClient[%i];
			%brick.eventOutputIdx[%i] = %col.eventOutputIdx[%i];
			for(%j = 1; %col.getOutputParameter(%i, %j) !$= ""; %j++)
			{
				%brick.setOutputParameter(%i, %j, %col.getOutputParameter(%i, %j));
			}
			%brick.eventTarget[%i] = %col.eventTarget[%i];
			%brick.eventTargetIdx[%i] = %col.eventTargetIdx[%i];
		}
		%col.delete();
	}
}
//COPIER//
$SwissArmyGun::Mode_["Copy"] = "Bricks";
$SwissArmyGun::ModeWelcome_["Copy"] = "Allows you to copy individual bricks.";
$SwissArmyGun::ModeNo[$SwissArmyGun::ModeCount++] = "Copy";
function SwissArmyGun_Copy_Brick(%obj, %col, %fade, %pos, %normal)
{
	%client = %obj.getControllingClient();
	if(getTrustLevel(%client, %col) >= 2)
	{
		if(isObject(%temp = %obj.tempBrick))
		{
			serverCmdCancelBrick(%client);
		}
		%brick = new FxDtsBrick()
		{
			position          = %col.position;
			oriPosition       = %col.position;
			rotation          = %col.rotation;
			oriRotation       = %col.rotation;
			dataBlock         = %col.dataBlock;
			oriDataBlock      = %col.dataBlock;
			angleId           = %col.angleId;
			oriAngleId        = %col.angleId;
			colorId           = %col.colorId;
			oriColorId        = %col.colorId;
			printId           = %col.printId;
			oriPrintId        = %col.printId;
			emitterDiection   = %col.emitterDirection;
			oriIsRaycasting   = %col.isRaycasting();
			oriIsColliding    = %col.isColliding();
			oriIsRendering    = %col.isRendering();
			itemDirection     = %col.itemDirection;
			itemPosition      = %col.itemPosition;
			itemResawnTime    = %col.itemRespawnTime;
			colorFxId         = %col.colorFxID;
			shapeFxId         = %col.shapeFxID;
			vehicleDatablock  = %col.vehicleDatablock;
			client            = %client;
			transferProperties= true;
		};
		%obj.tempBrick = %brick;
		if(isObject(%col.emitter))
		{
			%brick.emitterData = %col.emitter.emitter;
		}
		if(isObject(%col.light))
		{
			%brick.lightData = %col.light.getDatablock();
		}
		if(isObject(%col.item))
		{
			%brick.itemData = %col.item.getDatablock();
		}
		if(isObject(%col.audioEmitter))
		{
			%brick.musicData = %col.audioEmitter.profile;
		}
		//Events
		%brick.numEvents = %col.numEvents;
		for(%i = 0; %i < %col.numEvents; %i++)
		{
			%brick.eventDelay[%i] = %col.eventDelay[%i];
			%brick.eventEnabled[%i] = %col.eventEnabled[%i];
			%brick.eventInput[%i] = %col.eventInput[%i];
			%brick.eventInputIdx[%i] = %col.eventInputIdx[%i];
			%brick.eventOutput[%i] = %col.eventOutput[%i];
			%brick.eventOutputAppendClient[%i] = %col.eventOutputAppendClient[%i];
			%brick.eventOutputIdx[%i] = %col.eventOutputIdx[%i];
			for(%j = 1; %col.getOutputParameter(%i, %j) !$= ""; %j++)
			{
				%brick.setOutputParameter(%i, %j, %col.getOutputParameter(%i, %j));
			}
			%brick.eventTarget[%i] = %col.eventTarget[%i];
			%brick.eventTargetIdx[%i] = %col.eventTargetIdx[%i];
		}
	}
}
function FxDTSbrick::getOutputParameter(%this, %event, %param)
{
	return %this.eventOutputParameter[%event, %param];
}
function FxDTSbrick::setOutputParameter(%this, %eventN, %paramN, %value)
{
	%this.eventOutputParameter[%eventN, %paramN] = %value;
}
package SAG_MoveMode
{
	function serverCmdPlantBrick(%client)
	{
		if((%brick = %client.player.tempBrick).transferProperties)
		{
			%result = new FxDTSbrick()
			{
				position = %brick.getPosition();
				rotation = rotFromTransform(%brick.getTransform());
				datablock = %brick.getDatablock();
				colorID = %brick.colorID;
				angleID = %brick.angleID;
				client = %client;
			};
			if(%result.plant())
			{
				%result.delete();
				return parent::serverCmdPlantBrick(%client);
			}
			%client.brickGroup.add(%result);
			%result.setTrusted(true);
			//Properties
			%result.setRaycasting(%brick.oriIsRaycasting);
			%result.setColliding(%brick.oriIsColliding);
			%result.setRendering(%brick.oriIsRendering);
			//FX
			%result.setColorFx(%brick.colorFxId);
			%result.setShapeFx(%brick.shapeFxId);
			//Music	
			if(strLen(%brick.musicData) > 0)
			{
				%result.setMusic(%brick.musicData);
			}
			//Light
			if(strLen(%light = %brick.lightData) > 0)
			{
				%result.setLight(%light);
			}
			//Item
			%result.itemDirection = %brick.itemDirection;
			%result.itemPosition = %brick.itemPosition;
			%result.itemResawnTime = %brick.itemRespawnTime;
			if(strLen(%item = %brick.itemData) > 0)
			{
				%result.setItem(%item);
			}
			//Emitter
			if(strLen(%emitter = %brick.emitterData) > 0)
			{
				%result.setEmitter(%emitter);
			}
			%result.setEmitterDirection(%brick.emitterDirection);
			//Vehicle
			if(isObject(%vehi = %brick.vehicleDatablock))
			{
				%result.setVehicle(%vehi);
				%result.schedule(10, spawnVehicle);
			}
			//Events
			%result.numEvents = %brick.numEvents;
			for(%i = 0; %i < %brick.numEvents; %i++)
			{
				%result.eventDelay[%i] = %brick.eventDelay[%i];
				%result.eventEnabled[%i] = %brick.eventEnabled[%i];
				%result.eventInput[%i] = %brick.eventInput[%i];
				%result.eventInputIdx[%i] = %brick.eventInputIdx[%i];
				%result.eventOutput[%i] = %brick.eventOutput[%i];
				%result.eventOutputAppendClient[%i] = %brick.eventOutputAppendClient[%i];
				%result.eventOutputIdx[%i] = %brick.eventOutputIdx[%i];
				for(%j = 1; %brick.getOutputParameter(%i, %j) !$= ""; %j++)
				{
					%result.setOutputParameter(%i, %j, %brick.getOutputParameter(%i, %j));
				}
				%result.eventTarget[%i] = %brick.eventTarget[%i];
				%result.eventTargetIdx[%i] = %brick.eventTargetIdx[%i];
			}
			if(%brick.delAfterPlant)
			{
				%brick.delete();
				%client.player.tempBrick = "";
			}
		}
		else
		{
			%result = parent::serverCmdPlantBrick(%client);
		}
		return %result;
	}
	function serverCmdCancelBrick(%client)
	{
		if(isObject(%brick = %client.player.tempBrick))
		{
			if(%brick.delAfterPlant)
			{
				%brick.setTransform(%brick.oriPosition SPC %brick.oriRotation);
				%brick.rotation = %brick.oriRotation;
				%brick.setDatablock(%brick.oriDatablock);
				%brick.angleID = %brick.oriAngleID;
				%brick.colorID = %brick.oriColorID;
				%brick.printID = %brick.oriPrintID;
				%result = serverCmdPlantBrick(%client);
				if(!isObject(%result))
				{
					commandToClient(%client, 'messageBoxYesNo', "Error", "An error occured while moving the brick to its original position. Would you like to delete the brick?", 'SAGcancelbrick');
					return;
				}
			}
		}
		parent::serverCmdCancelBrick(%client);
	}
	function serverCmdSAGcancelbrick(%client)
	{
		if(isObject(%temp = %client.player.tempBrick))
		{
			%temp.delete();
		}
		%client.player.tempBrick = "";
	}
};
activatePackage(SAG_MoveMode);