//HAMMER//
$SwissArmyGun::Mode_["Hammer"] = "Bricks";
$SwissArmyGun::ModeWelcome_["Hammer"] = "Emulates the Hammer tool.";
$SwissArmyGun::ModeNo[$SwissArmyGun::ModeCount++] = "Hammer";
function SwissArmyGun_Hammer_Brick(%obj, %col, %pos)
{
	hammerImage.onHitObject(%obj, 0, %col, %pos, "0 0 1");
}

//WRENCH//
$SwissArmyGun::Mode_["Wrench"] = "Bricks";
$SwissArmyGun::ModeNo[$SwissArmyGun::ModeCount++] = "Wrench";
function SwissArmyGun_Wrench_Brick(%obj, %col, %pos)
{
	wrenchImage.onHitObject(%obj, 0, %col, %pos, "0 0 1");
}

//PRINTER//
$SwissArmyGun::Mode_["Print"] = "Bricks";
$SwissArmyGun::ModeWelcome_["Print"] = "Emulates the Printgun tool.";
$SwissArmyGun::ModeNo[$SwissArmyGun::ModeCount++] = "Print";
function SwissArmyGun_Print_Brick(%obj, %col, %pos)
{
	printgunImage.onHitObject(%obj, 0, %col, %pos, "0 0 1");
}

//PLANTER//
$SwissArmyGun::Mode_["Plant"] = "Bricks\tInteriors\tTerrain";
$SwissArmyGun::ModeWelcome_["Plant"] = "Emulates the Brick Planting tool.";
$SwissArmyGun::ModeNo[$SwissArmyGun::ModeCount++] = "Plant";
function SwissArmyGun_Plant_Brick(%obj, %col, %pos)
{
	brickDeployProjectile.onCollision(%obj, %col, 0, %pos, "0 0 1");
}
function SwissArmyGun_Plant_Interior(%obj, %col, %pos)
{
	brickDeployProjectile.onCollision(%obj, %col, 0, %pos, "0 0 1");
}
function SwissArmyGun_Plant_Terrain(%obj, %col, %pos)
{
	brickDeployProjectile.onCollision(%obj, %col, 0, %pos, "0 0 1");
}

//WAND//
$SwissArmyGun::Mode_["Wand"] = "Bricks\tPlayers";
$SwissArmyGun::ModeWelcome_["Wand"] = "Emulates the standard wand. If you're an Admin, the destructo wand is automatically used.";
$SwissArmyGun::ModeNo[$SwissArmyGun::ModeCount++] = "Wand";
function SwissArmyGun_Wand_Brick(%obj, %col, %pos)
{
	%image = (%obj.getControllingClient().isAdmin ? "adminWandImage" : "wandImage");
	%image.onHitObject(%obj, 0, %col, %pos, "0 0 1");
}
function SwissArmyGun_Wand_Player(%obj, %col, %pos)
{
	%image = (%obj.getControllingClient().isAdmin ? "adminWandImage" : "wandImage");
	%image.onHitObject(%obj, 0, %col, %pos, "0 0 1");
}

//PAINT CANS//
$SwissArmyGun::Mode_["Paint"] = "Bricks\tPlayers\tVehicles";
$SwissArmyGun::ModeWelcome_["Paint"] = "Emulates the paint can. Works with FX cans and color cans alike.";
$SwissArmyGun::ModeNo[$SwissArmyGun::ModeCount++] = "Paint";
function SwissArmyGun_Paint_Brick(%obj, %col, %pos)
{
	if(isObject(%client = %obj.getControllingClient()))
	{
		if(%client.currentColor $= "")
		{
			%client.currentColor = 0;
		}
		if(%client.currentFxCan > 0)
		{
			switch(%client.currentFxCan)
			{
				case 1: %proj = flatPaintProjectile;
				case 2: %proj = pearlPaintProjectile;
				case 3: %proj = chromePaintProjectile;
				case 4: %proj = glowPaintProjectile;
				case 5: %proj = blinkPaintProjectile;
				case 6: %proj = swirlPaintProjectile;
				case 7: %proj = rainbowPaintProjectile;
				case 8: %proj = stablePaintProjectile;
				case 9: %proj = jelloPaintProjectile;
			}
		}
		else
		{
			%proj = "color" @ %client.currentColor @ "paintProjectile";
		}
		%proj.onCollision(%obj, %col, 0, %pos, "0 0 1");
	}
}
function SwissArmyGun_Paint_Player(%obj, %col, %pos)
{
	if(isObject(%client = %obj.sourceObject.getControllingClient()))
	{
		if(%client.currentColor $= "")
		{
			%client.currentColor = 0;
		}
		%proj = "color" @ %client.currentColor @ "paintProjectile";
		%proj.onCollision(%obj, %col, 0, %pos, "0 0 1");
	}
}
function SwissArmyGun_Paint_Vehicle(%obj, %col, %pos)
{
	if(isObject(%client = %obj.getControllingClient()))
	{
		if(%client.currentColor $= "")
		{
			%client.currentColor = 0;
		}
		%proj = "color" @ %client.currentColor @ "paintProjectile";
		%proj.onCollision(%obj, %col, 0, %pos, "0 0 1");
	}
}